import java.util.HashMap;

public class Reflector{
 private final String type;
 private final HashMap<Character,Character> mapping;

 public Reflector(String startType){
     this.type = startType;
     this.mapping = typeToMapping();
 }
    public HashMap<Character, Character> getMapping() {
        return mapping;
    }

    public char[] reflectorSelection(){
        if (this.type.equals("UKW-B")) return "YRUHQSLDPXNGOKMIEBFZCWVJAT".toCharArray();
        else return "FVPJIAOYEDRZXWGCTKUQSBNMHL".toCharArray();
    }

    public HashMap<Character,Character> typeToMapping(){
        char[] input = "ABCDEFGHIJKLMNOPQRSTUVWXYZ".toCharArray();
        char[] output = reflectorSelection();
        HashMap<Character, Character> rotorMapping = new HashMap<>();
        for(int n =0; n < input.length;n++) {
            rotorMapping.put(input[n],output[n]);
        }
        return rotorMapping;
    }

}
