import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;

public class ViewBasicMain {
    private final JFrame basicFrame = new JFrame("Main Screen");
    private final JButton buttonRotorOne = new JButton("Fast Rotor");
    private final JButton buttonRotorTwo = new JButton("Medium Rotor");
    private final JButton buttonRotorThree = new JButton("Slow Rotor");
    private final JButton buttonReflector = new JButton("Reflector");
    private final JButton buttonPlugboard = new JButton("Plugboard");
    private final JButton buttonEnter = new JButton("Enter");
    private final JButton buttonIncrease = new JButton("-->");
    private final JButton buttonDecrease = new JButton("<--");
    private final JButton buttonRandom = new JButton("Generate Task");
    private final JButton buttonInfo = new JButton("Background Info");
    private final JButton buttonInstruction = new JButton("Instructions");
    private final JTextField textOutput = new JTextField();
    private final JTextField textInput = new JTextField();
    private final JTextField textIndex = new JTextField("0");
    private final JLabel labelInput = new JLabel("Input Text: ");
    private final JLabel labelOutput = new JLabel("Output Text: ");
    private final JLabel labelPlugboardGraphic = new JLabel();
    private final JLabel labelRotor1Graphic = new JLabel();
    private final JLabel labelRotor2Graphic = new JLabel();
    private final JLabel labelRotor3Graphic = new JLabel();
    private final JLabel labelReflectorGraphic = new JLabel();
    private final JTextField txtPlugForward = new JTextField();
    private final JTextField txtPlugBackward = new JTextField();
    private final JTextField txtRotor1Forward = new JTextField();
    private final JTextField txtRotor1Backward = new JTextField();
    private final JTextField txtRotor2Forward = new JTextField();
    private final JTextField txtRotor2Backward = new JTextField();
    private final JTextField txtRotor3Forward = new JTextField();
    private final JTextField txtRotor3Backward = new JTextField();
    private final JTextField txtPlainChar = new JTextField();
    private final JTextField txtCypherChar = new JTextField();
    private final StyleContext con = new StyleContext();
    private final DefaultStyledDocument doc = new DefaultStyledDocument(con);
    private final Style defaultStyle = con.addStyle("Default",null);

    public void setupMain(){
        basicFrame.setDefaultCloseOperation(basicFrame.EXIT_ON_CLOSE);
        String directory = System.getProperty("user.dir");
        buttonRotorOne.setBounds(10,20,150,25);
        basicFrame.add(buttonRotorOne);
        buttonRotorTwo.setBounds(10,55,150,25);
        basicFrame.add(buttonRotorTwo);
        buttonRotorThree.setBounds(10,90,150,25);
        basicFrame.add(buttonRotorThree);
        buttonReflector.setBounds(10,125,150,25);
        basicFrame.add(buttonReflector);
        buttonPlugboard.setBounds(10,160,150,25);
        basicFrame.add(buttonPlugboard);
        labelInput.setBounds(200,30,100,25);
        basicFrame.add(labelInput);
        labelOutput.setBounds(200,90,100,25);
        basicFrame.add(labelOutput);
        textInput.setBounds(300,20,205,50);
        basicFrame.add(textInput);
        textOutput.setBounds(300,80,205,50);
        basicFrame.add(textOutput);
        buttonEnter.setBounds(200,135,304,50);
        basicFrame.add(buttonEnter);
        buttonRandom.setBounds(550,80,150,25);
        basicFrame.add(buttonRandom);
        buttonInfo.setBounds(550,110,150,25);
        basicFrame.add(buttonInfo);
        buttonInstruction.setBounds(550,140,150,25);
        basicFrame.add(buttonInstruction);
        labelPlugboardGraphic.setBounds(65, 250,75,150);
        ImageIcon plugIcon = new ImageIcon(directory + "\\Image Dump\\EnigmaGraphic1.png");
        labelPlugboardGraphic.setIcon(plugIcon);
        basicFrame.add(labelPlugboardGraphic);
        labelRotor1Graphic.setBounds(175, 250,90,150);
        ImageIcon r1Icon = new ImageIcon(directory + "\\Image Dump\\EnigmaGraphic2.png");
        labelRotor1Graphic.setIcon(r1Icon);
        basicFrame.add(labelRotor1Graphic);
        labelRotor2Graphic.setBounds(300, 250,90,150);
        ImageIcon r2Icon = new ImageIcon(directory + "\\Image Dump\\EnigmaGraphic3.png");
        labelRotor2Graphic.setIcon(r2Icon);
        basicFrame.add(labelRotor2Graphic);
        labelRotor3Graphic.setBounds(425, 250,90,150);
        ImageIcon r3Icon = new ImageIcon(directory + "\\Image Dump\\EnigmaGraphic4.png");
        labelRotor3Graphic.setIcon(r3Icon);
        basicFrame.add(labelRotor3Graphic);
        labelReflectorGraphic.setBounds(550, 250,90,150);
        ImageIcon reflIcon = new ImageIcon(directory + "\\Image Dump\\EnigmaGraphic5.png");
        labelReflectorGraphic.setIcon(reflIcon);
        basicFrame.add(labelReflectorGraphic);
        txtPlugForward.setBounds(147, 302,20,20);
        basicFrame.add(txtPlugForward);
        txtPlugBackward.setBounds(147, 358,20,20);
        basicFrame.add(txtPlugBackward);
        txtRotor1Forward.setBounds(272, 298,20,20);
        basicFrame.add(txtRotor1Forward);
        txtRotor1Backward.setBounds(272, 362,20,20);
        basicFrame.add(txtRotor1Backward);
        txtRotor2Forward.setBounds(397, 302,20,20);
        basicFrame.add(txtRotor2Forward);
        txtRotor2Backward.setBounds(397, 362,20,20);
        basicFrame.add(txtRotor2Backward);
        txtRotor3Forward.setBounds(522, 298,20,20);
        basicFrame.add(txtRotor3Forward);
        txtRotor3Backward.setBounds(522, 362,20,20);
        basicFrame.add(txtRotor3Backward);
        txtPlainChar.setBounds(42, 298,20,20);
        basicFrame.add(txtPlainChar);
        txtCypherChar.setBounds(42, 362,20,20);
        basicFrame.add(txtCypherChar);
        basicFrame.setSize(725, 525);
        basicFrame.setLayout(null);
        basicFrame.setVisible(true);
        buttonDecrease.setBounds(250,210,70,25);
        basicFrame.add(buttonDecrease);
        buttonIncrease.setBounds(375,210,70,25);
        basicFrame.add(buttonIncrease);
        textIndex.setBounds(325,210,45,25);
        basicFrame.add(textIndex);
    }

    public JButton getButtonEnter() {
        return buttonEnter;
    }

    public JButton getButtonPlugboard() {
        return buttonPlugboard;
    }

    public JButton getButtonReflector() {
        return buttonReflector;
    }

    public JButton getButtonRotorOne() {
        return buttonRotorOne;
    }

    public JButton getButtonRotorTwo() {
        return buttonRotorTwo;
    }

    public JButton getButtonRotorThree() {
        return buttonRotorThree;
    }
    public JButton getButtonRandom(){return buttonRandom;}
    public JFrame getBasicFrame() {
        return basicFrame;
    }

    public String getInputText() {
        return textInput.getText();
    }
    public void setOutputText(String message){
        textOutput.setText(message);
    }

    public JButton getButtonDecrease() {
        return buttonDecrease;
    }

    public JButton getButtonIncrease() {
        return buttonIncrease;
    }

    public JButton getButtonInfo() {
        return buttonInfo;
    }

    public JButton getButtonInstruction() {
        return buttonInstruction;
    }

    public int getGUIIndex(){
        return Integer.parseInt(textIndex.getText());
    }
    public void setGUIIndex(int newIndex){
        textIndex.setText(String.valueOf(newIndex));
    }
    public void setTxtPlugForward(String message){
        txtPlugForward.setText(message);
    }
    public void setTxtPlugBackward(String message){
        txtPlugBackward.setText(message);
    }
    public void setTxtRotor1Forward(String message){
        txtRotor1Forward.setText(message);
    }
    public void setTxtRotor2Forward(String message){
        txtRotor2Forward.setText(message);
    }
    public void setTxtRotor3Forward(String message){
        txtRotor3Forward.setText(message);
    }
    public void setTxtRotor1Backward(String message){
        txtRotor1Backward.setText(message);
    }
    public void setTxtRotor2Backward(String message){
        txtRotor2Backward.setText(message);
    }
    public void setTxtRotor3Backward(String message){
        txtRotor3Backward.setText(message);
    }
    public void setTxtCypherChar(String message){
        txtCypherChar.setText(message);
    }
    public void setTxtPlainChar(String message){
        txtPlainChar.setText(message);
    }

    public void mainInfo() throws BadLocationException {
        JDialog dia = new JDialog(basicFrame,"Home Screen Information Window");
        defaultStyle.addAttribute(StyleConstants.Foreground, new Color(0,0,0));
        defaultStyle.addAttribute(StyleConstants.FontSize, 14);
        defaultStyle.addAttribute(StyleConstants.Family,"Helvetica");
        JTextPane textInstructions = new JTextPane(doc);
        textInstructions.setEditable(false);
        dia.add(textInstructions);
        String msg = "The M3 enigma machine is an encryption machine used by Germany during the later half of WW2. " +
                "It was difficult for the allied forces to crack the cipher during the war as the machine had rotors " +
                "that would change how a letter would be encrypted by rotating after each input, causing the cipher to " +
                "constantly change. The enigma machine contains 3 different components; A plugboard, three rotors and a " +
                "reflector. German radio operators would change the plugboard configuration, change the starting position " +
                "of the rotor and which of the 8 rotor and 2 reflector variants would be used. " +
                "These changes were done everyday so the allied forces could not use the same method they had used on " +
                "previously intercepted and decoded messages.\n\nWhen a user would press a letter on the keyboard, a " +
                "signal would get passed through each component as shown in the simplified graphic on the main screen. As the wire connects two " +
                "letters, one at each end, there is no separate mode for encoding and decoding. Instead, if the initial " +
                "component settings are identical, the cipher text can be inputted into the enigma machine to get the plain text." ;
        doc.insertString(0,msg,defaultStyle);
        textInstructions.setBounds(5,20,400,150);
        dia.setSize(500,385);
        dia.setVisible(true);
    }

    public void mainInstruct() throws BadLocationException {
        JDialog dia = new JDialog(basicFrame,"Home Screen Instructions");
        defaultStyle.addAttribute(StyleConstants.Foreground, new Color(0,0,0));
        defaultStyle.addAttribute(StyleConstants.FontSize, 14);
        defaultStyle.addAttribute(StyleConstants.Family,"Helvetica");
        JTextPane textInstructions = new JTextPane(doc);
        textInstructions.setEditable(false);
        dia.add(textInstructions);
        String msg = "You can configure the settings of all the simulation's component using the buttons at the top left of the Main Screen.\n" +
                "Work your way down through those five buttons, each button is labelled for what component it will allow you to edit.\n" +
                "After you have changed the settings to your preference, enter a phrase into the 'input text' box and press the 'Enter' button on the GUI\n" +
                "to see the encrypted version of your message in the 'output text'.\n" +
                "The graphic at the bottom of the main screen will show the encryption at every step for your letter.\n" +
                "By pressing the arrow button you can change what letter of your message is being shown, with '0' being the first letter of your message. \n" +
                "If you wish to see the background information for any screen press the 'Background Info' button to learn more.\n" +
                "The 'Generate Task' button will generate you quick tasks to complete and tell you if you are correct or not.";
        doc.insertString(0,msg,defaultStyle);
        textInstructions.setBounds(5,20,400,150);
        dia.setSize(500,385);
        dia.setVisible(true);
    }
}
