import javax.swing.*;

public class ViewTutorial {
    private final JFrame tutorialFrame = new JFrame("Tutorial Questions");
    private final JLabel labelIntro = new JLabel("Click the button to generate a question to try!");
    private final JLabel labelText = new JLabel("If the settings are set as: ");
    private final JLabel labelFRotor = new JLabel("Fast Rotor - Type: ### - Position: ###");
    private final JLabel labelMRotor = new JLabel("Medium Rotor - Type: ### - Position: ###");
    private final JLabel labelSRotor = new JLabel("Slow Rotor - Type: ### - Position: ###");
    private final JLabel labelReflect = new JLabel("Reflector - Type: ###");
    private final JLabel labelPlugboard = new JLabel("Plugboard Pairs - ## ## ## ## ##");
    private final JLabel labelInputText = new JLabel("And enter the following text: ########");
    private final JLabel labelOutput = new JLabel("Enter your output here!");
    private final JLabel labelAnswer = new JLabel("Your answer is: ");
    private final JTextField textUserAnswer = new JTextField();
    private final JButton buttonBack = new JButton("Return");
    private final JButton buttonCheck = new JButton("Check Answer");
    private final JButton buttonGenerate = new JButton("Generate Question");
    public void setupTutorial(){
        tutorialFrame.setDefaultCloseOperation(tutorialFrame.EXIT_ON_CLOSE);
        buttonGenerate.setBounds(5,20,150,25);
        tutorialFrame.add(buttonGenerate);
        labelIntro.setBounds(5, 50,300,25);
        tutorialFrame.add(labelIntro);
        buttonBack.setBounds(250,350,150,25);
        tutorialFrame.add(buttonBack);

        buttonCheck.setBounds(5,350,150,25);
        labelText.setBounds(5,50,300,25);
        labelFRotor.setBounds(5,80,300,25);
        labelMRotor.setBounds(5,110,300,25);
        labelSRotor.setBounds(5,140,300,25);
        labelReflect.setBounds(5,170,300,25);
        labelPlugboard.setBounds(5,200,300,25);
        labelInputText.setBounds(5,230,300,25);
        labelOutput.setBounds(5,260,300,25);
        textUserAnswer.setBounds(5,290,300,25);
        labelAnswer.setBounds(5,320,300,25);

        tutorialFrame.add(buttonCheck);
        tutorialFrame.add(labelText);
        tutorialFrame.add(labelFRotor);
        tutorialFrame.add(labelMRotor);
        tutorialFrame.add(labelSRotor);
        tutorialFrame.add(labelReflect);
        tutorialFrame.add(labelPlugboard);
        tutorialFrame.add(labelInputText);
        tutorialFrame.add(labelOutput);
        tutorialFrame.add(textUserAnswer);
        tutorialFrame.add(labelAnswer);

        buttonCheck.setVisible(false);
        labelText.setVisible(false);
        labelFRotor.setVisible(false);
        labelMRotor.setVisible(false);
        labelSRotor.setVisible(false);
        labelReflect.setVisible(false);
        labelPlugboard.setVisible(false);
        labelInputText.setVisible(false);
        labelOutput.setVisible(false);
        textUserAnswer.setVisible(false);
        labelAnswer.setVisible(false);

        tutorialFrame.setSize(525, 750);
        tutorialFrame.setLayout(null);
        tutorialFrame.setVisible(false);
    }

    public void populateTutorial(){
        labelIntro.setVisible(false);

        buttonCheck.setVisible(true);
        labelText.setVisible(true);
        labelFRotor.setVisible(true);
        labelMRotor.setVisible(true);
        labelSRotor.setVisible(true);
        labelReflect.setVisible(true);
        labelPlugboard.setVisible(true);
        labelInputText.setVisible(true);
        labelOutput.setVisible(true);
        textUserAnswer.setVisible(true);
        labelAnswer.setVisible(true);
    }

    //Helpers

    public JButton getButtonBack() {return buttonBack;}
    public JButton getButtonCheck() {return buttonCheck;}
    public JButton getButtonGenerate() {return buttonGenerate;}
    public JFrame getTutorialFrame() {return tutorialFrame;}
    public JTextField getTextUserAnswer() {return textUserAnswer;}

    public void setLabelFRotor(String type, String position){
        labelFRotor.setText("Fast Rotor - Type: " + type + " - Position: " + position);
    }
    public void setLabelMRotor(String type, String position){
        labelMRotor.setText("Medium Rotor - Type: " + type + " - Position: " + position);
    }
    public void setLabelSRotor(String type, String position){
        labelSRotor.setText("Slow Rotor - Type: " + type + " - Position: " + position);
    }
    public void setLabelReflect(String type){
        labelReflect.setText("Reflector - Type: " + type);
    }
    public void setLabelPlugboard(String pairs){
        labelPlugboard.setText("Plugboard Pairs - " + pairs);
    }
    public void setLabelAnswer(String msg){
        labelAnswer.setText("Your answer is: " + msg);
    }
    public void setLabelInputText(String message){
        labelInputText.setText("And enter the following text: " + message);
    }
}
